C ESA (C) 2000-2018 
C
C This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
C
C    SAS is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    SAS is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
      subroutine getarea(x1, x2, y1, y2, e1, e2, area)
c
c  Assuming you have function values y1 at x1 and y2 at x2, calculates
c  the contribution to the area between e1 and e2
c
      implicit none

      real x1, x2, y1, y2, e1, e2, area
      real emin, emax, ymin, ymax
      real xd, yd

c Case where no overlap
c
      if ((x1 .ge. e2) .or. (x2 .le. e1)) then
        area = 0.0
        return
      endif

c Case where complete overlap
c
      if ((x1 .ge. e1) .and. (x2 .le. e2)) then
        area = 0.5 * (y1 + y2) * (x2 - x1)
        return
      endif

c Case where partial overlap
c
      xd = x2 - x1
      yd = y2 - y1

      if (x1 .lt. e1) then
        ymin = y1 + (yd * (e1 - x1) / xd)
        emin = e1
      else
        ymin = y1
        emin = x1
      endif        

      if (x2 .gt. e2) then
        ymax = y1 + (yd * (e2 - x1) / xd)
        emax = e2
      else
        ymax = y2
        emax = x2
      endif        

      area = 0.5 * (ymin + ymax) * (emax - emin)

      return
      end
