C ESA (C) 2000-2018 
C
C This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
C
C    SAS is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    SAS is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
      real function lorentz(e1, e0, sigma)
c
c Returns the unormalised value of a Lorentz function
c
      implicit none

c  Local Variables
      real e1, e0, sigma, var1

c  Local Constants
      real threshold
      parameter (threshold = 5.0e-3)

c  External Functions

c  Common Parameters

c-
      var1 = ((e1-e0)/sigma)**2
      lorentz = 1.0 / (1.0 + (0.5*var1))
      if (lorentz .lt. threshold) then
        lorentz = 0.0
      endif

      return
      end





