C ESA (C) 2000-2018 
C
C This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
C
C    SAS is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    SAS is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
      real function si_redgauss(e1, main_energy, main_sigma, 
     1                            red_sigma, flo_norm, flo_sigma,
     2                            esc_norm, esc_sigma)
c
c  Returns the value of the main Si Photopeak + Fluoresence and Escape
c  Contributions at energy, e1
c
      implicit none

c  Local Variables
      real main_energy, main_sigma, red_sigma
      real flo_norm, flo_sigma, esc_norm, esc_sigma
      real e1, escape, si_flo, si_esc

c  Local Constants
      real si_kedge, si_kalpha

c  External Functions
      real redgauss

      common /silicon/ si_kedge, si_kalpha
c-
c Main Peak
      si_redgauss = redgauss(e1, main_energy, main_sigma, red_sigma)

      if (main_energy .gt. si_kedge) then
c
c Fluoresence Peak
          si_flo = flo_norm * redgauss(e1, si_kalpha, flo_sigma,
     &                                  red_sigma)
c
c Escape Peak
          escape = main_energy - si_kalpha
          si_esc = esc_norm * redgauss(e1, escape, esc_sigma,
     &                                  red_sigma)

          si_redgauss = si_redgauss + (si_flo + si_esc)

      endif

      return
      end





