C ESA (C) 2000-2018 
C
C This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
C
C    SAS is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    SAS is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
      real function simpson(f, a, b, n)
c
c  Evaluates an integral using Simpson's rule
c
c  Local Variables
      implicit none

      integer i, n

      real f, a, b, h
      real x, feven, fodd, h2

      h = (b - a) / float(n)
      h2 = h * 2.0
c 
c  Sum even terms
      feven = 0.0
      x = a + h2
      do i = 2, n-2, 2
          feven = feven + f(x)
          x = x + h2
      enddo
c
c  Sum odd terms
      fodd = 0.0
      x = a + h
      do i = 1, n-1, 2
          fodd = fodd + f(x)
          x = x + h2
      enddo

      simpson = h * ((f(a)+f(b)) + (2.0*feven) + (4.0*fodd)) / 3.0

      return
      end




