C ESA (C) 2000-2018 
C
C This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
C
C    SAS is free software: you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    SAS is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
      real function sloss_fraction(depth, alpha, beta)
c
c  Calculates the fractional charge loss of X-rays of energy MAIN_ENERGY 
c  at depth=depth microns
c
      implicit none

      real depth
      real alpha, beta

c-
c  Calculate Loss fraction

      sloss_fraction = alpha + (beta * depth)
      if( sloss_fraction .gt. 1.0 ) then
          sloss_fraction = 1.0
      endif
      if( sloss_fraction .lt. 0.0 ) then
          sloss_fraction = 0.0
      endif

      return
      end
